#include	"adpcm.h"

// RXgN^
Adpcm::Adpcm(){
}

// fXgN^
Adpcm::~Adpcm(){
}

// ADPCMϊiDELTAj
BYTE* Adpcm::waveToAdpcm(void *pData,DWORD dSize,DWORD &dAdpcmSize,DWORD dRate,DWORD dPadSize){
	// RIFFwb_mF
	m_pRiffHed = reinterpret_cast<RIFF_HED*>(pData);
	// wb_`FbN
	if(m_pRiffHed->bID[0] != 'R' && m_pRiffHed->bID[1] != 'I' && m_pRiffHed->bID[2] != 'F' && m_pRiffHed->bID[3] != 'F'){
		return NULL;
	}
	// WAVEwb_`FbN(CHUNK_HEDp)
	CHUNK_HED *pChunk = reinterpret_cast<CHUNK_HED*>(static_cast<BYTE*>(pData) + 0x00000008);
	if(pChunk->bID[0] != 'W' && pChunk->bID[1] != 'A' && pChunk->bID[2] != 'V' && pChunk->bID[3] != 'E'){
		return NULL;
	}
	// 擪`Nݒ
	pChunk = reinterpret_cast<CHUNK_HED*>(reinterpret_cast<DWORD>(pChunk) + 4);
	m_pWaveChunk = NULL;
	m_pDataChunk = NULL;
	while(reinterpret_cast<DWORD>(pChunk) < reinterpret_cast<DWORD>(pData) + dSize)
	{
		// fmt`N̏ꍇ
		if(pChunk->bID[0] == 'f' && pChunk->bID[1] == 'm' && pChunk->bID[2] == 't' && pChunk->bID[3] == ' '){
			// fmt`NAhX擾
			m_pWaveChunk = reinterpret_cast<WAVE_CHUNK*>(pChunk);
		}
		// data`N̏ꍇ
		if(pChunk->bID[0] == 'd' && pChunk->bID[1] == 'a' && pChunk->bID[2] == 't' && pChunk->bID[3] == 'a'){
			// data`NAhX擾
			m_pDataChunk = reinterpret_cast<DATA_CHUNK*>(pChunk);
		}
		// ̃`NփAhXZ
		pChunk = reinterpret_cast<CHUNK_HED*>(reinterpret_cast<DWORD>(pChunk) + pChunk->dChunkSize + 8);
	}
	// fmt`Nydata`N݂邩
	if(m_pWaveChunk == NULL || m_pDataChunk == NULL){
		// ݂ȂꍇNG
		return NULL;
	}
	// jAPCM`FbN
	if(m_pWaveChunk->wFmt != 0x0001){
		// jAPCMȊONGɂ
		return NULL;
	}

	// wavef[^TvO
	DWORD	dPcmSize;
	short	*pPcm = resampling(dPcmSize,dRate,dPadSize);
	// TvOłȂꍇ
	if(pPcm == NULL){
		return NULL;
	}

	// adpcmϊ
	BYTE	*pAdpcm = new BYTE[dPcmSize / 2];
	encode(pPcm,pAdpcm,dPcmSize);
	dAdpcmSize = dPcmSize / 2;
	delete [] pPcm;
	return	pAdpcm;
}

// TvO
short* Adpcm::resampling(DWORD &dSize,DWORD dRate,DWORD dPadSize){
	// tH[}bg`FbNi16bitȊOmfj
	if(m_pWaveChunk->wSample != 16){
		return NULL;
	}
	// m
	short *pPcm;
	int		iPcmSize = 0;
	if(m_pWaveChunk->wChannels == 2){
		iPcmSize = static_cast<int>(m_pDataChunk->dSize / 4);
		pPcm = new short[iPcmSize];		// ̃TCYɂȂ
		short	*pSrc = reinterpret_cast<short*>(&m_pDataChunk->bData[0]);
		short	*pDis = pPcm;
		for(int iCnt = 0; iCnt < iPcmSize; iCnt++){
			int	iPcm = *pSrc++;	// k
			iPcm += *pSrc++;	// q
			iPcm /= 2;
			*pDis++ = static_cast<short>(iPcm);
		}
	}else if(m_pWaveChunk->wChannels == 1){
		iPcmSize = static_cast<int>(m_pDataChunk->dSize / 2);
		pPcm = new short[iPcmSize];
		memcpy(pPcm,&m_pDataChunk->bData[0],m_pDataChunk->dSize);
	}else{
		return NULL;
	}
	// TvO
	int iSrcRate = static_cast<int>(m_pWaveChunk->dRate);	// wavẽ[g
	int iDisRate = (int)dRate;
	int iDiff = 0;
	int	iSampleSize = 0;
	// TvÕt@CTCYZo
	for(int iCnt = 0; iCnt < iPcmSize; iCnt++){
		iDiff += iDisRate;
		while(iDiff >= iSrcRate){
			// o
			iSampleSize++;
			iDiff -= iSrcRate;
		}
	}
	if(iDiff > 0) iSampleSize++;

	// TvÕobt@쐬
	int iResampleBuffSize = iSampleSize;
	if(iSampleSize % (dPadSize * 2) > 0) iResampleBuffSize += ((dPadSize * 2) - (iSampleSize % (dPadSize * 2)));
	short *pResampleBuff = new short[iResampleBuffSize];
	ZeroMemory(pResampleBuff,sizeof(short) * iResampleBuffSize);
	// TvO{
	short iSampleCnt = 0;
	int iSmple = 0;
	iDiff = 0;
	iSmple = 0;
	short *pResampleDis = pResampleBuff;
	// TvÕt@CTCYZo
	BOOL	bUpdate = FALSE;
	if(iDisRate != static_cast<int>(m_pWaveChunk->dRate)){
		for(int iCnt = 0; iCnt < iPcmSize; iCnt++){
			iSmple += static_cast<int>(pPcm[iCnt]);		// TvZ
			iSampleCnt++;
			iDiff += iDisRate;
			bUpdate = FALSE;
			while(iDiff >= iSrcRate){
				*pResampleDis++ = static_cast<short>(iSmple / iSampleCnt);
				// o
				iDiff -= iSrcRate;
				bUpdate = TRUE;
			}
			if(bUpdate == TRUE){
				iSampleCnt = 0;
				iSmple = 0;
				bUpdate = FALSE;
			}
		}
		if(iSampleCnt > 0){
			*pResampleDis++ = static_cast<short>(iSmple / iSampleCnt);
		}
	}else{
		for(int iCnt = 0; iCnt < iPcmSize; iCnt++){
			*pResampleDis++ = pPcm[iCnt];
		}
	}
	// \[XPCMobt@j
	delete [] pPcm;
	dSize = iResampleBuffSize;
	return	pResampleBuff;
}

// GR[h
int Adpcm::encode(short *pSrc,unsigned char *pDis,DWORD iSampleSize){
	static long stepsizeTable[ 16 ] =
	{
		57, 57, 57, 57, 77,102,128,153,
		57, 57, 57, 57, 77,102,128,153
	};
	int iCnt;
	long i , dn , xn , stepSize;
	unsigned char adpcm;
	unsigned char adpcmPack;

	// lݒ
	xn			= 0;
	stepSize	= 127;
	
	for( iCnt = 0 ; iCnt < static_cast<int>(iSampleSize) ; iCnt++ ){
		// GR[h
		dn = *pSrc - xn;		// o
		pSrc++;
		i = (abs(dn) << 16) / (stepSize << 14);
		if(i > 7){
			i = 7;
		}
		adpcm = (unsigned char)i;
		i = (adpcm * 2 + 1) * stepSize >> 3;
		if(dn < 0){
			adpcm |= 0x8;
			xn -= i;
		}else{
			xn += i;
		}
		stepSize = (stepsizeTable[adpcm] * stepSize) / 64;
		if(stepSize < 127){
			stepSize = 127;
		}else if( stepSize > 24576 ){
			stepSize = 24576;
		}
		// ADPCMf[^
		if((iCnt & 0x01) == 0){
			adpcmPack = (adpcm << 4);
		}else{
			adpcmPack |= adpcm;
			*pDis = adpcmPack;
			pDis++;
		}
	}
	return 0;
}

