#include "realchip.h"

// RXgN^
realchip::realchip()
{
	// tO
	m_IsRealChip = false;
	// ADPCMpobt@NA
	memset(m_bADPCMBuff, 0x00, sizeof(m_bADPCMBuff));
}

// fXgN^
realchip::~realchip()
{
}

// 
void realchip::Initialize()
{
	// SCCIǂݍ
	m_hScci = ::LoadLibrary((LPCSTR)"scci.dll");
	if (m_hScci == NULL) {
		return;
	}
	// TEhC^[tF[X}l[W[擾p֐AhX擾
	SCCIFUNC getSoundInterfaceManager = (SCCIFUNC)(::GetProcAddress(m_hScci, "getSoundInterfaceManager"));
	if (getSoundInterfaceManager == NULL) {
		::FreeLibrary(m_hScci);
		m_hScci = NULL;
		return;
	}
	// TEhC^[tF[X}l[W[擾
	m_pManager = getSoundInterfaceManager();

	// 
	m_pManager->initializeInstance();

	// Zbg
	m_pManager->reset();

	// TEh`bv擾
	m_pSoundChip = m_pManager->getSoundChip(SC_TYPE_YM2608, SC_CLOCK_7987200);

	// TEh`bv̎擾oȂꍇ
	if (m_pSoundChip == NULL)
	{
		// TEh}l[W[ďI
		m_pManager->releaseInstance();
		::FreeLibrary(m_hScci);
		m_hScci = NULL;
		return;
	}
	// `bv擾ł̂ŃA`bvœ삳
	m_IsRealChip = true;
}

// J
void realchip::UnInitialize()
{
	// A`bvȂ瑦I
	if (m_IsRealChip == false) return;
	// TEh`bvJ
	m_pManager->releaseSoundChip(m_pSoundChip);
	m_pSoundChip = NULL;
	// TEh}l[W[J
	m_pManager->releaseInstance();
	m_pManager = NULL;
	// DLLJ
	::FreeLibrary(m_hScci);
	m_hScci = NULL;
}

// Zbg
void realchip::Reset()
{
	// `bv݂Ȃꍇ
	if (m_IsRealChip == false) {
		return;
	}
	// Zbg
	if (m_pSoundChip) {
		m_pSoundChip->init();
	}
}

// A`bv`FbN
bool realchip::IsRealChip(){
	// A`bv̗Lԋp
	return m_IsRealChip;
}

// WX^ݒ
void realchip::SetRegister(DWORD reg, DWORD data) {
	if (m_pSoundChip) {
		m_pSoundChip->setRegister(reg, data);
	}
}

// ADPCM̓]
void realchip::SendAdpcmData(void *pData, DWORD size) {
	// 邩`FbN
	if (memcmp(m_bADPCMBuff, pData, size) == 0) {
		// ꍇ͓]Ȃ
		return;
	}
	// Rs[
	memcpy(m_bADPCMBuff, pData, size);
	// [H̓[߂
	memset(&m_bADPCMBuff[size], 0x00, 0x40000 - size);
	// ]TCYvZipfBOlj
	DWORD transSize = size + ((0x20 - (size & 0x1f)) & 0x1f);

	m_pSoundChip->setRegister(0x100, 0x20);
	m_pSoundChip->setRegister(0x100, 0x21);
	m_pSoundChip->setRegister(0x100, 0x00);
	m_pSoundChip->setRegister(0x110, 0x00);
	m_pSoundChip->setRegister(0x110, 0x80);

	m_pSoundChip->setRegister(0x100, 0x61);
	m_pSoundChip->setRegister(0x100, 0x68);
	m_pSoundChip->setRegister(0x101, 0x00);

	// AhX
	m_pSoundChip->setRegister(0x102, 0x00);
	m_pSoundChip->setRegister(0x103, 0x00);
	m_pSoundChip->setRegister(0x104, 0xff);
	m_pSoundChip->setRegister(0x105, 0xff);
	m_pSoundChip->setRegister(0x10c, 0xff);
	m_pSoundChip->setRegister(0x10d, 0xff);
	// PCM]
	for (DWORD dCnt = 0; dCnt < transSize; dCnt++) {
		m_pSoundChip->setRegister(0x108, m_bADPCMBuff[dCnt]);
	}
	// I
	m_pSoundChip->setRegister(0x100, 0x00);
	m_pSoundChip->setRegister(SC_WAIT_REG, 16);
	m_pSoundChip->setRegister(0x110, 0x80);
	m_pSoundChip->setRegister(SC_WAIT_REG, 16);

	// obt@ɂȂ܂ő҂
	while (!m_pSoundChip->isBufferEmpty()) {
		Sleep(0);
	}
	
}
